Dynamic Link Exchange Protocol (DLEP) Diffserv Aware Credit Window Extension
RFC 9894
Bow-Nan Cheng
MIT Lincoln Laboratory
Massachusetts Institute of Technology
244 Wood Street
Lexington
MA
02421-6426
United States of America
bcheng@ll.mit.edu
David Wiggins
Lou Berger
LabN Consulting, L.L.C.
lberger@labn.net
Donald E. Eastlake 3rd, Ed.
Independent
2386 Panoramic Circle
Apopka
FL
32703
United States of America
+1-508-333-2270
d3e3e3@gmail.com
November 2025
RTG
manet
This document defines an extension to the Dynamic Link Exchange Protocol (DLEP) that enables a Diffserv aware credit-window scheme for destination-specific and shared flow control.
Introduction
The Dynamic Link Exchange Protocol (DLEP) is defined in [RFC8175]. The protocol provides the exchange of link-related control information between DLEP peers. DLEP peers consist of a modem and a router. DLEP defines a base set of mechanisms as well as support for possible extensions. This document defines one such extension.
The DLEP specification does not include any flow control capability. Various flow control techniques are theoretically possible with DLEP. This document defines a DLEP extension that provides a Diffserv-based flow control mechanism for traffic sent from a router to a modem. Flow control is provided using one or more logical "Credit Windows", each of which will typically be supported by an associated virtual or physical queue. A router will use traffic flow classification information provided by the modem to identify which traffic is associated with each credit window. Credit windows may be shared or dedicated on a per-flow basis. See [RFC9895] for an Ethernet-based version of credit window flow control. As specified in Section 2.3.1 of [RFC9892], when both Diffserv and Ethernet traffic classification are specified for a flow, the Ethernet information takes precedence.
This document uses the traffic classification and credit window control mechanisms defined in [RFC9892] and [RFC9893] to provide credit-window-based flow control based on DLEP destinations and Differentiated Services Code Points (DSCPs) [RFC2475]. The defined mechanism allows for credit windows to be shared across traffic sent to multiple DLEP destinations and DSCPs, or used exclusively for traffic sent to a particular destination and/or DSCP. The extension also supports the "wildcard" matching of any DSCP.
The extension defined in this document is referred to as the "Diffserv Aware Credit Window" or, more simply, the "DA Credit" extension. The reader should be familiar with both the traffic classification and credit window control mechanisms defined in [RFC9892] and [RFC9893].
This document defines a new DLEP Extension Type Value that is used to indicate support for the extension. See Section 2.
Key Words
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Extension Usage and Identification
The extension defined in this document is composed of the mechanisms and processing defined in [RFC9892] and [RFC9893]. To indicate that the Diffserv Aware Credit Window Extension is to be used, an implementation MUST include the Diffserv Aware Credit Window Type Value in the Extensions Supported Data Item (see Section 13.6 of [RFC8175]). The Extensions Supported Data Item is sent and processed according to [RFC8175]. Any implementation that indicates the use of the Diffserv Aware Credit Window Extension MUST support all message types, Data Items, the Diffserv Traffic Classification Sub-Data Item, and all related processing defined in [RFC9892] and [RFC9893].
The Diffserv Aware Credit Window Extension Type Value is 6. See Section 5.
Management Considerations
This section provides several network management guidelines for implementations supporting the Diffserv Aware Credit Window Extension.
If this extension is supported, that support MUST be declared using the Extensions Supported Data Item (see Section 13.6 of [RFC8175]). Diffserv Aware Credit Window Extension Data Items MUST NOT be emitted by a DLEP participant unless such support was specified in the initialization message received from its peer. The use of the extension defined in this document SHOULD be configurable on both modems and routers. That configuration can be implemented using a proprietary Command-Line Interface (CLI) or by implementing a YANG module. The definition of the YANG module is out of scope for this document.
Modems SHOULD support the configuration of mapping a DSCP to a credit window (queue).
Modems MAY support the configuration of the number of credit windows (queues) to advertise to a router.
Routers may have limits on the number of queues that they can support and limits on supported credit window combinations. Per-destination queues might not be supported at all. When credit window information provided by a modem exceeds the capabilities of a router, the router SHOULD use a subset of the provided credit windows. Alternatively, a router MAY reset the session and indicate that the extension is not supported. In either case, any mismatch in capabilities SHOULD be reported to the user via normal network management mechanisms, such as user interface messages or error logging.
In all cases, if credit windows are in use, traffic for which credits are not available MUST NOT be sent to the modem by the router.
Security Considerations
This document defines a DLEP extension that uses DLEP mechanisms and the credit window control and flow mechanisms defined in [RFC9892] and [RFC9893]. See also the Security Considerations sections of those documents.
The defined extension is exposed to vulnerabilities similar to existing DLEP messages and discussed in the Security Considerations section of [RFC8175], such as an injected message resizing a credit window to a value that results in a denial of service. The security mechanisms documented in [RFC8175] can be applied equally to the mechanism defined in this document.
Wildcards for matching Priority Code Point (PCP) and VLAN Identifier (VID) fields (see [RFC9895]) are provided. Note that wildcards may be convenient for matching a number of packet flows but could inadvertently match unexpected flows or new flows that appear after the wildcard matching has been set up. It is therefore RECOMMENDED that wildcards not be used unless needed.
IANA Considerations
IANA has assigned the following code point in the "Extension Type Values" registry in the "Dynamic Link Exchange Protocol (DLEP) Parameters" registry group:
Extension Type Value
Code | Description
6 | Diffserv Aware Credit Window
References
Normative References
[RFC9893]

Dynamic Link Exchange Protocol (DLEP) Credit-Based Flow Control Messages and Data Items
Bow-Nan Cheng
MIT Lincoln Laboratory
David Wiggins
Stan Ratliff
Lou Berger
LabN Consulting, L.L.C.
Eric Kinzie, Ed.
LabN Consulting, L.L.C.
November 2025
RFC 9893
DOI 10.17487/RFC9893
[RFC9892]

Dynamic Link Exchange Protocol (DLEP) Traffic Classification Data Item
Bow-Nan Cheng
MIT Lincoln Laboratory
David Wiggins
Lou Berger
LabN Consulting, L.L.C.
Don Fedyk, Ed.
LabN Consulting, L.L.C.
November 2025
RFC 9892
DOI 10.17487/RFC9892
Informative References
[RFC9895]

Dynamic Link Exchange Protocol (DLEP) IEEE 802.1Q Aware Credit Window Extension
David Wiggins
Lou Berger
LabN Consulting, L.L.C.
Donald E. Eastlake 3rd, Ed.
Independent
November 2025
RFC 9895
DOI 10.17487/RFC9895
[RFC8175]
[RFC2475]
[RFC2119]
[RFC8174]
Acknowledgments
The Sub-Data Item format was inspired by Rick Taylor's "Data Item Containers". He also proposed the separation of credit windows from traffic classification at IETF 98. Many useful comments were received from contributors to the MANET Working Group, notably Ronald in 't Velt.
We had the honor of working too briefly with David Wiggins on this and related DLEP work. His contribution to the IETF and publication of the first and definitive open-source DLEP implementation have been critical to the acceptance of DLEP. We mourn his passing on November 26, 2023. We wish to recognize his guidance, leadership, and professional excellence. We were fortunate to benefit from his leadership and friendship. He shall be missed.